#ifndef __TVTTS_FNC__
#define __TVTTS_FNC__

void TVTT_Calc(BYTE *DataA, BYTE*DataB);
BYTE TVTT_Check(BYTE *DataA, BYTE*DataB);
void TVTT_CalcSessionKey(BYTE SessionKey[16], BYTE PassPC[16], BYTE RandPC[16], BYTE PassT[16], BYTE RandT[16]);
void TVTT_CryptBlock(BYTE Block[16], DWORD Key, BYTE Pass[16], BYTE BlockNr, BYTE Direction);

void TVTT_RandInit(BYTE Init[16*4]);
void TVTT_RandGetInit(BYTE Init[16*4]);
void TVTT_Randomize(BYTE SrcNr,DWORD Data);
void TVTT_Rand(BYTE Rand[16]);

#endif

//---------------------------------------------------------------------------
// Stae biblioteki

#define TVTT_BLOCK_A                    0                                   /* staa definujca numer bloku danych przy szyfrowaniu pierwszego bloku danych - na potrzeby funkcji generujcej hasa tymczasowe */
#define TVTT_BLOCK_B                    1                                   /* staa definujca numer bloku danych przy szyfrowaniu drugiego bloku danych - na potrzeby funkcji generujcej hasa tymczasowe */
#define TVTT_PC2T                       0                                   /* staa definujca kierunek przesania wiadomoci z PC do Tokenu - na potrzeby funkcji generujcej hasa tymczasowe */
#define TVTT_T2PC                       1                                   /* staa definujca kierunek przesania wiadomoci z Tokenu do PC - na potrzeby funkcji generujcej hasa tymczasowe */

#define TVTT_RAND_INIT_TBL_SIZE         (16*4)                              /* staa definiujca rozmiar tablicy inicjujcej generator liczb pseudolosowych */

#define TVTTS_OK                        0

//---------------------------------------------------------------------------
// Kody bdw zwracane przez DLL

#ifndef __TVTTS_CONST__
#define __TVTTS_CONST__

#define TVTTS_INVALID_HANDLE            0x0100
#define TVTTS_NULL_PTR                  0x0200
#define TVTTS_BAD_PARAM                 0x0300
#define TVTTS_TOO_MANY_OPEN_TOKENS      0x0400
#define TVTTS_USB_DOES_NOT_EXIST        0x0500
#define TVTTS_TOKEN_NOT_FOUND           0x0600
#define TVTTS_TIME_OUT                  0x0700
#define TVTTS_SEQ_EXPIRED               0x0800
#define TVTTS_ALREADY_OPENED            0x0900
#define TVTTS_UNKNOWN_ERROR             0x1000
#define TVTTS_DLL_INIT_FAILED           0xFF00

//---------------------------------------------------------------------------

// kody statusu Tokenu:
#define TVTTS_NO_OPEN                   0x11
#define TVTTS_EXPIRED                   0x12
#define TVTTS_DAMAGED                   0x13

#define TVTTS_NOT_SUPPORTED             0x21
#define TVTTS_OUT_OF_RANGE              0x22
#define TVTTS_PROTECTION_NOT_SUPPORTED  0x23

#define TVTTS_PASS_NOT_PERMITTED        0x31
#define TVTTS_NOT_PERMITTED             0x32
#define TVTTS_ACCESS_EXPIRED            0x33

//---------------------------------------------------------------------------
// definicja pl tablicy opisujcej moliwoci tokenu
#define TVTTTI_ID                       0
#define TVTTTI_NV_MEM_SIZE              1
#define TVTTTI_RAM_SIZE                 2
#define TVTTTI_PROTECT_MEM_SIZE         3
#define TVTTTI_PASS_TABLE_SIZE          4
#define TVTTTI_BITS_PER_PASS            5
#define TVTTTI_COUNTERS                 6
#define TVTTTI_BITS_PER_COUNTER         7
#define TVTTTI_EXT_VERSION              8

#define TVTTTI_TABLE_SIZE               9

//---------------------------------------------------------------------------
// definicja standardowych pl w drugim bloku danych
#define TVTTD_CMD                       0
#define TVTTD_STATUS                    0
#define TVTTD_PARAM1                    1
#define TVTTD_PARAM2                    2
#define TVTTD_PARAM3                    3
#define TVTTD_AUTH                      4

//---------------------------------------------------------------------------
// kody rozkazw tokenu
#define TVTTC_OPEN                      0x01
#define TVTTC_CLOSE                     0x02
#define TVTTC_FORMAT                    0x0F

#define TVTTC_NVMEM_READ                0x11
#define TVTTC_NVMEM_WRITE               0x12
#define TVTTC_NVMEM_WRITE_PROTECT       0x13
#define TVTTC_NVMEM_PROTECT             0x14
#define TVTTC_NVMEM_DECRYPT_WRITE       0x15

#define TVTTC_VMEM_READ                 0x91
#define TVTTC_VMEM_WRITE                0x92

#define TVTTC_ENCRYPT                   0x21
#define TVTTC_DECRYPT                   0x22

#define TVTTC_CNT_READ                  0x31
#define TVTTC_CNT_INC_READ              0x32
#define TVTTC_CNT_DEC_READ              0x33
#define TVTTC_CNT_WRITE                 0x34
#define TVTTC_CNT_INC_ENCRYPT_READ      0x35
#define TVTTC_CNT_WRITE_CONFIG          0x36
#define TVTTC_CNT_SET_CONFIG            0x37
#define TVTTC_CNT_CLR_CONFIG            0x38
#define TVTTC_CNT_DECRYPT_WRITE         0x39

#define TVTTC_PASS_WRITE                0x41
#define TVTTC_PASS_WRITE_CONFIG         0x42
#define TVTTC_PASS_SET_CONFIG           0x43
#define TVTTC_PASS_CLR_CONFIG           0x44

// podrozkazy do rozkazu TVTTC_CNT_DECRYPT_WRITE
#define TVTTCS_CNT_WRITE                0x00
#define TVTTCS_CNT_INC                  0x01
#define TVTTCS_CNT_DEC                  0x02

//---------------------------------------------------------------------------
// bity konfiguracji hase

#define TVTTPC0_TOKEN                   0x01
#define TVTTPC0_PASS_WRITE              0x02
#define TVTTPC0_PASS_CONFIG             0x04
#define TVTTPC0_MEM_READ                0x08
#define TVTTPC0_MEM_WRITE               0x10
#define TVTTPC0_ENCRYPT                 0x20
#define TVTTPC0_DECRYPT                 0x40
#define TVTTPC0_DECRYPT_WRITE           0x80

#define TVTTPC1_CNT_READ                0x01
#define TVTTPC1_CNT_WRITE               0x02
#define TVTTPC1_CNT_CONFIG              0x04
#define TVTTPC1_ENCRYPT_PASS            0x08
#define TVTTPC1_DECRYPT_PASS            0x10
#define TVTTPC1_CNT_ENCRYPT_PASS        0x20
#define TVTTPC1_WRITE_ENABLED           0x40
#define TVTTPC1_CONFIG_ENABLED          0x80

//---------------------------------------------------------------------------
// bity konfiguracji licznikw

#define TVTTCC0_WRITE                   0x01
#define TVTTCC0_READ                    0x02
#define TVTTCC0_INC_READ                0x04
#define TVTTCC0_DEC_READ                0x08
#define TVTTCC0_INC_ENCRYPT_READ        0x10
#define TVTTCC0_STOP_AT_ZERO            0x20
#define TVTTCC0_NVMEM_READ              0x40
#define TVTTCC0_NVMEM_WRITE             0x80

#define TVTTCC1_PASS                    0x01
#define TVTTCC1_NVMEM_DECRYPT_WRITE     0x02
#define TVTTCC1_CONFIG_ENABLED          0x80

#endif
